#pragma once
#include "afxwin.h"
#include "afxcmn.h"

#include "SocketHandle.h"
#include "SocketClientImpl.h"


// CSearchDlg ȭ Դϴ.

class CSearchDlg :  public CDialog,
					public ISocketClientHandler

{
    typedef SocketClientImpl<ISocketClientHandler> CSocketClient;
    friend CSocketClient;

	DECLARE_DYNAMIC(CSearchDlg)

public:
	CSearchDlg(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CSearchDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_DIALOG_SEARCH };

protected:
    CSocketClient	m_SocketClient;

public:
	CString m_strSelectAddress;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

public:
	void GetLocalAddress();
	void GetAddress(const SockAddrIn& addrIn, CString& rAddress, CString& rPort) const;
	bool GetBroadcast(SockAddrIn& addrIn);
	bool GetSelectAddress(CString& refAddress);

	bool ConnectLocal();

    // SocketClient Interface handler
    virtual void OnThreadBegin(CSocketHandle* pSH);
    virtual void OnThreadExit(CSocketHandle* pSH);
    virtual void OnDataReceived(CSocketHandle* pSH, const BYTE* pbData, DWORD dwCount, const SockAddrIn& addr);
    virtual void OnConnectionDropped(CSocketHandle* pSH);
    virtual void OnConnectionError(CSocketHandle* pSH, DWORD dwError);


	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	CComboBox m_cmbSubnet;
	CListCtrl m_listVisions;
	CButton m_btnOK;
protected:
	virtual void OnOK();
public:
	afx_msg void OnBnClickedBtnSearch();
	afx_msg void OnDestroy();
	afx_msg void OnCbnSelchangeCmbSubnet();
	afx_msg void OnLvnItemchangedListVisions(NMHDR *pNMHDR, LRESULT *pResult);
};
